{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_ErrorState
  ( C_ES, d_C_evalES, nd_C_evalES, d_C_returnES, d_C_failES, d_OP_gt_plus_eq
  , nd_OP_gt_plus_eq, d_OP_gt_plus, nd_OP_gt_plus, d_OP_lt_dollar_gt
  , nd_OP_lt_dollar_gt, d_OP_lt_star_gt, nd_OP_lt_star_gt, d_C_gets, d_C_puts
  , d_C_modify, nd_C_modify, d_C_mapES, nd_C_mapES, d_C_concatMapES
  , nd_C_concatMapES, d_C_mapAccumES, nd_C_mapAccumES )
  where

import Basics
import qualified Curry_Prelude


type C_ES t0 t1 t2 = t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 t2 t1)

d_C_evalES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 t2
d_C_evalES x1 x2 cd cs = d_C__case_3 x2 x1 (Curry_Prelude.d_C_apply x1 x2 cd cs)
  cd cs

nd_C_evalES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => Func t0 (Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0)) -> t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 t2
nd_C_evalES x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_3 x2 x1 (Curry_Prelude.nd_C_apply x1 x2 s0 cd
  cs) s1 cd cs))

d_C_returnES ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 t0 t1)
d_C_returnES x1 x2 cd cs = Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x1 x2)

d_C_failES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => t0 -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t2 t1)
d_C_failES x1 x2 cd cs = Curry_Prelude.C_Left x1

d_OP_gt_plus_eq ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> (t2 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)) -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)
d_OP_gt_plus_eq x1 x2 x3 cd cs = d_C__case_1 x3 x1 x2 (Curry_Prelude.d_C_apply
  x1 x3 cd cs) cd cs

nd_OP_gt_plus_eq ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> Func t2 (Func
  t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0))) -> t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0)
nd_OP_gt_plus_eq x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_1 x3 x1 x2 (Curry_Prelude.nd_C_apply x1 x3 s0
  cd cs) s1 cd cs))

d_OP_gt_plus ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0)) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)
d_OP_gt_plus x1 x2 cd cs = d_OP_gt_plus_eq x1
  (d_OP_gt_plus_dot_uscore_hash_lambda3 x2)

nd_OP_gt_plus ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)) -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0))
nd_OP_gt_plus x1 x2 s cd cs = wrapNX id (nd_OP_gt_plus_eq x1 (wrapNX id
  (nd_OP_gt_plus_dot_uscore_hash_lambda3 x2)))

d_OP_gt_plus_dot_uscore_hash_lambda3 ::(Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0)) -> t3 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)
d_OP_gt_plus_dot_uscore_hash_lambda3 x1 x2 cd cs = x1

nd_OP_gt_plus_dot_uscore_hash_lambda3 ::(Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> t3 -> IDSupply -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0))
nd_OP_gt_plus_dot_uscore_hash_lambda3 x1 x2 s cd cs = x1

d_OP_lt_dollar_gt ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => (t0 -> Cover
  -> ConstStore -> t1) -> (t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  t3 (Curry_Prelude.OP_Tuple2 t0 t2)) -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2 t1 t2)
d_OP_lt_dollar_gt x1 x2 cd cs = d_OP_gt_plus_eq x2
  (d_OP_lt_dollar_gt_dot_uscore_hash_lambda4 x1)

nd_OP_lt_dollar_gt ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => Func t0 t1 -> Func t2
  (Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2 t0 t2)) -> IDSupply
  -> Cover -> ConstStore -> Func t2 (Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 t1 t2))
nd_OP_lt_dollar_gt x1 x2 s cd cs = wrapNX id (nd_OP_gt_plus_eq x2 (wrapNX id
  (nd_OP_lt_dollar_gt_dot_uscore_hash_lambda4 x1)))

d_OP_lt_dollar_gt_dot_uscore_hash_lambda4 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => (t0 -> Cover -> ConstStore -> t1) -> t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2
  t1 t2)
d_OP_lt_dollar_gt_dot_uscore_hash_lambda4 x1 x2 cd cs = d_C_returnES
  (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_lt_dollar_gt_dot_uscore_hash_lambda4 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => Func t0 t1 -> t0 -> IDSupply -> Cover -> ConstStore -> Func t2
  (Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2 t1 t2))
nd_OP_lt_dollar_gt_dot_uscore_hash_lambda4 x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapDX id (d_C_returnES (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs))

d_OP_lt_star_gt ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (t2
  -> Cover -> ConstStore -> t3) t0)) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0)
d_OP_lt_star_gt x1 x2 cd cs = d_OP_gt_plus_eq x1
  (d_OP_lt_star_gt_dot_uscore_hash_lambda5 x2)

nd_OP_lt_star_gt ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Func t2 t3) t0)) -> Func
  t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0))
nd_OP_lt_star_gt x1 x2 s cd cs = wrapNX id (nd_OP_gt_plus_eq x1 (wrapNX id
  (nd_OP_lt_star_gt_dot_uscore_hash_lambda5 x2)))

d_OP_lt_star_gt_dot_uscore_hash_lambda5 ::(Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0)) -> (t2 -> Cover -> ConstStore -> t3) -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0)
d_OP_lt_star_gt_dot_uscore_hash_lambda5 x1 x2 cd cs = d_OP_gt_plus_eq x1
  (d_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x2)

nd_OP_lt_star_gt_dot_uscore_hash_lambda5 ::(Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> Func t2 t3 -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0))
nd_OP_lt_star_gt_dot_uscore_hash_lambda5 x1 x2 s cd cs = wrapNX id
  (nd_OP_gt_plus_eq x1 (wrapNX id
  (nd_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x2)))

d_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 ::(Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => (t0 -> Cover -> ConstStore -> t1) -> t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2
  t1 t2)
d_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 cd cs =
  d_C_returnES (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 ::(Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => Func t0 t1 -> t0 -> IDSupply -> Cover -> ConstStore -> Func t2
  (Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2 t1 t2))
nd_OP_lt_star_gt_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` wrapDX id (d_C_returnES (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs))

d_C_gets ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t0 t0)
d_C_gets x1 cd cs = Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x1 x1)

d_C_puts ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit t0)
d_C_puts x1 x2 cd cs = Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit x1)

d_C_modify ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t0)
d_C_modify x1 x2 cd cs = Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.d_C_apply x1 x2 cd cs))

nd_C_modify ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t0 t0
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t0)
nd_C_modify x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs))

d_C_mapES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t3, Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 t3 t1))
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)
d_C_mapES x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C_returnES Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_OP_gt_plus_eq (Curry_Prelude.d_C_apply x1 x3
    cd cs) (d_OP_mapES_dot_uscore_hash_lambda7 x1 x4)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapES x1 l cd cs)
    (d_C_mapES x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapES x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_mapES x1 e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "ErrorState.mapES"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "ErrorState.mapES" (showCons x2))

nd_C_mapES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1) => Func t0 (Func t1
  (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 t3 t1)))
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore -> Func t1
  (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3)
  t1))
nd_C_mapES x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> wrapDX id (d_C_returnES Curry_Prelude.OP_List)
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` wrapNX id (nd_OP_gt_plus_eq (Curry_Prelude.nd_C_apply x1 x3 s0
    cd cs) (wrapNX id (nd_OP_mapES_dot_uscore_hash_lambda7 x1 x4)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapES x1 l s cd cs)
    (nd_C_mapES x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapES x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_mapES x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "ErrorState.mapES"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "ErrorState.mapES" (showCons x2))

d_OP_mapES_dot_uscore_hash_lambda7 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 t3 t1))
  -> Curry_Prelude.OP_List t0 -> t3 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)
d_OP_mapES_dot_uscore_hash_lambda7 x1 x2 x3 cd cs = d_OP_gt_plus_eq (d_C_mapES
  x1 x2 cd cs) (d_OP_mapES_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 x3)

nd_OP_mapES_dot_uscore_hash_lambda7 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t1) => Func t0 (Func t1 (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 t3
  t1))) -> Curry_Prelude.OP_List t0 -> t3 -> IDSupply -> Cover -> ConstStore
  -> Func t1 (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1))
nd_OP_mapES_dot_uscore_hash_lambda7 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_OP_gt_plus_eq (nd_C_mapES x1 x2 s0 cd cs) (wrapDX
  (wrapDX id) (d_OP_mapES_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 x3)))

d_OP_mapES_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 ::(Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t1)
d_OP_mapES_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 x1 x2 cd cs =
  d_C_returnES (Curry_Prelude.OP_Cons x1 x2)

d_C_concatMapES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1) => (t0 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1))
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)
d_C_concatMapES x1 x2 cd cs = d_OP_lt_dollar_gt Curry_Prelude.d_C_concat
  (d_C_mapES x1 x2 cd cs) cd cs

nd_C_concatMapES ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1) => Func t0 (Func t1
  (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3)
  t1))) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore -> Func
  t1 (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  t3) t1))
nd_C_concatMapES x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_dollar_gt (wrapDX id Curry_Prelude.d_C_concat)
  (nd_C_mapES x1 x2 s0 cd cs) s1 cd cs))

d_C_mapAccumES ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t2) => (t0 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 t0 t4) t2)) -> t0 -> Curry_Prelude.OP_List t1
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  t4)) t2)
d_C_mapAccumES x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C_returnES (Curry_Prelude.OP_Tuple2 x2
    Curry_Prelude.OP_List)
  Curry_Prelude.OP_Cons x4 x5 -> d_OP_gt_plus_eq (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x2 cd cs) x4 cd cs)
    (d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x5)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapAccumES x1 x2 l cd
    cs) (d_C_mapAccumES x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapAccumES
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_mapAccumES x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ErrorState.mapAccumES" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ErrorState.mapAccumES" (showCons x3))

nd_C_mapAccumES ::(Curry_Prelude.Curry t1, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t2) => Func t0 (Func t1 (Func t2 (Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 t4) t2)))) -> t0
  -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore -> Func t2
  (Curry_Prelude.C_Either t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List t4)) t2))
nd_C_mapAccumES x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> wrapDX id (d_C_returnES (Curry_Prelude.OP_Tuple2 x2
    Curry_Prelude.OP_List))
  Curry_Prelude.OP_Cons x4 x5 -> let s2 = s
    in s2 `seq` wrapNX id (nd_OP_gt_plus_eq (let s1 = leftSupply s2
                                                 s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x2 s0 cd cs) x4 s1 cd cs)) (wrapNX id
    (nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x5)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapAccumES x1 x2 l s
    cd cs) (nd_C_mapAccumES x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapAccumES
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_mapAccumES x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ErrorState.mapAccumES" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ErrorState.mapAccumES" (showCons x3))

d_OP_mapAccumES_dot_uscore_hash_lambda9 ::(Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t2) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 t4) t2))
  -> Curry_Prelude.OP_List t1 -> Curry_Prelude.OP_Tuple2 t0 t4 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  t4)) t2)
d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_OP_gt_plus_eq (d_C_mapAccumES x1 x4 x2 cd
    cs) (d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x5)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 l cd cs)
    (d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState.mapAccumES._#lambda9" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ErrorState.mapAccumES._#lambda9" (showCons x3))

nd_OP_mapAccumES_dot_uscore_hash_lambda9 ::(Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t2) => Func t0 (Func t1 (Func t2 (Curry_Prelude.C_Either
  t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 t4) t2))))
  -> Curry_Prelude.OP_List t1 -> Curry_Prelude.OP_Tuple2 t0 t4 -> IDSupply
  -> Cover -> ConstStore -> Func t2 (Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  t4)) t2))
nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` wrapNX id (nd_OP_gt_plus_eq (nd_C_mapAccumES x1 x4 x2 s0 cd cs)
    (wrapDX (wrapDX id)
    (d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x5)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 l s cd cs)
    (nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_mapAccumES_dot_uscore_hash_lambda9 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState.mapAccumES._#lambda9" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ErrorState.mapAccumES._#lambda9" (showCons x3))

d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 ::(Curry_Prelude.Curry
  t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => t0 -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List t0) -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t0)) t2)
d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C_returnES (Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.OP_Cons x1 x4))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 l cd
    cs) (d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumES_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState.mapAccumES._#lambda9._#lambda10" [show x1, show x2] info)
  _ -> failCons cd (consFail "ErrorState.mapAccumES._#lambda9._#lambda10"
    (showCons x2))

d_C__case_1 ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> (t2 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0))
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)
d_C__case_1 x3 x1 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_Left x4 -> Curry_Prelude.C_Left x4
  Curry_Prelude.C_Right x5 -> d_C__case_0 x2 x5 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_1 x3 x1 x2 l cd
    cs) (d_C__case_1 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_1 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_1 x3 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "ErrorState._case_1" [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "ErrorState._case_1" (showCons x6))

nd_C__case_1 ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => t0 -> Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0)) -> Func t2 (Func
  t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)))
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  t3 t0)
nd_C__case_1 x3 x1 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_Left x4 -> Curry_Prelude.C_Left x4
  Curry_Prelude.C_Right x5 -> let s0 = s in s0 `seq` nd_C__case_0 x2 x5 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_1 x3 x1 x2 l s
    cd cs) (nd_C__case_1 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_1 x3
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_1 x3 x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "ErrorState._case_1" [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "ErrorState._case_1" (showCons x6))

d_C__case_0 ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => (t2 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t3 t0)) -> Curry_Prelude.OP_Tuple2 t2 t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)
d_C__case_0 x2 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x2 l cd cs)
    (d_C__case_0 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_0 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState._case_0" [show x2, show x5] info)
  _ -> failCons cd (consFail "ErrorState._case_0" (showCons x5))

nd_C__case_0 ::(Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => Func t2 (Func t0
  (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)))
  -> Curry_Prelude.OP_Tuple2 t2 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t3 t0)
nd_C__case_0 x2 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x6 s0 cd cs) x7 s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x2 l s cd
    cs) (nd_C__case_0 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_0 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState._case_0" [show x2, show x5] info)
  _ -> failCons cd (consFail "ErrorState._case_0" (showCons x5))

d_C__case_3 ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => t0 -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 t2 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 t2
d_C__case_3 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> d_C__case_2 x4 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_3 x2 x1 l cd
    cs) (d_C__case_3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_3 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_3 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "ErrorState._case_3" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ErrorState._case_3" (showCons x5))

nd_C__case_3 ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => t0 -> Func t0 (Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0)) -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 t2 t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t1 t2
nd_C__case_3 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> d_C__case_2 x4 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_3 x2 x1 l s cd
    cs) (nd_C__case_3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_3 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_3 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "ErrorState._case_3" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ErrorState._case_3" (showCons x5))

d_C__case_2 ::(Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => Curry_Prelude.OP_Tuple2 t2 t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 t2
d_C__case_2 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.C_Right x5
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ErrorState._case_2" [show x4] info)
  _ -> failCons cd (consFail "ErrorState._case_2" (showCons x4))

