{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Installation
  ( d_C_compilerName, d_C_installDir, d_C_majorVersion, d_C_minorVersion
  , d_C_revisionVersion, d_C_compilerDate, d_C_installDate, d_C_runtime
  , d_C_runtimeMajor, d_C_runtimeMinor, d_C_ghcExec, d_C_ghcOptions
  , d_C_installGlobal, d_C_withProfiling )
  where

import Basics
import qualified Curry_Prelude

import qualified Installation as I

d_C_compilerName :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_compilerName cd cs = external_d_C_compilerName cd cs

d_C_installDir :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_installDir cd cs = external_d_C_installDir cd cs

d_C_majorVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_majorVersion cd cs = external_d_C_majorVersion cd cs

d_C_minorVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_minorVersion cd cs = external_d_C_minorVersion cd cs

d_C_revisionVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_revisionVersion cd cs = external_d_C_revisionVersion cd cs

d_C_compilerDate :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_compilerDate cd cs = external_d_C_compilerDate cd cs

d_C_installDate :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_installDate cd cs = external_d_C_installDate cd cs

d_C_runtime :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_runtime cd cs = external_d_C_runtime cd cs

d_C_runtimeMajor :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_runtimeMajor cd cs = external_d_C_runtimeMajor cd cs

d_C_runtimeMinor :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_runtimeMinor cd cs = external_d_C_runtimeMinor cd cs

d_C_ghcExec :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_ghcExec cd cs = external_d_C_ghcExec cd cs

d_C_ghcOptions :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_ghcOptions cd cs = external_d_C_ghcOptions cd cs

d_C_installGlobal :: Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_installGlobal cd cs = external_d_C_installGlobal cd cs

d_C_withProfiling :: Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_withProfiling cd cs = external_d_C_withProfiling cd cs

external_d_C_compilerName :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_compilerName _ _ = toCurry I.compilerName

external_d_C_installDir :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_installDir _ _ = toCurry I.installDir

external_d_C_majorVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
external_d_C_majorVersion _ _ = toCurry I.majorVersion

external_d_C_minorVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
external_d_C_minorVersion _ _ = toCurry I.minorVersion

external_d_C_revisionVersion :: Cover -> ConstStore -> Curry_Prelude.C_Int
external_d_C_revisionVersion _ _ = toCurry I.revisionVersion

external_d_C_compilerDate :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_compilerDate _ _ = toCurry I.compilerDate

external_d_C_installDate :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_installDate _ _ = toCurry I.installDate

external_d_C_runtime :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_runtime _ _ = toCurry I.runtime

external_d_C_runtimeMajor :: Cover -> ConstStore -> Curry_Prelude.C_Int
external_d_C_runtimeMajor _ _ = toCurry I.runtimeMajor

external_d_C_runtimeMinor :: Cover -> ConstStore -> Curry_Prelude.C_Int
external_d_C_runtimeMinor _ _ = toCurry I.runtimeMinor

external_d_C_ghcExec :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_ghcExec _ _ = toCurry I.ghcExec

external_d_C_ghcOptions :: Cover -> ConstStore -> Curry_Prelude.C_String
external_d_C_ghcOptions _ _ = toCurry I.ghcOptions

external_d_C_installGlobal :: Cover -> ConstStore -> Curry_Prelude.C_Bool
external_d_C_installGlobal _ _ = toCurry I.installGlobal

external_d_C_withProfiling :: Cover -> ConstStore -> Curry_Prelude.C_Bool
external_d_C_withProfiling _ _ = toCurry I.withProfiling
