{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Compile
  ( d_C_main, d_C_build, d_C_locateCurryFile, d_C_makeModule, nd_C_makeModule
  , d_C_writeAnalysis, nd_C_writeAnalysis, d_C_readAnalysis, nd_C_readAnalysis
  , d_C_loadAnalysis, nd_C_loadAnalysis, d_C_compileModule, nd_C_compileModule
  , d_C_extractFuncInfos, d_C_patchPreludeExports, d_C_compMessage
  , d_C_filterPrelude, d_C_integrateExternals, d_C_lookupExternals
  , d_C_splitExternals, d_C_dump, d_C_rename, d_C_defaultModules )
  where

import Basics
import qualified Curry_AbstractHaskell
import qualified Curry_AbstractHaskellGoodies
import qualified Curry_AbstractHaskellPrinter
import qualified Curry_Analysis
import qualified Curry_AnnotatedFlatCurryGoodies
import qualified Curry_Char
import qualified Curry_Classification
import qualified Curry_CompilerOpts
import qualified Curry_DefaultPolymorphic
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_EliminateCond
import qualified Curry_FilePath
import qualified Curry_Files
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_FlatCurryGoodies
import qualified Curry_Inference
import qualified Curry_LiftCase
import qualified Curry_List
import qualified Curry_Maybe
import qualified Curry_Message
import qualified Curry_MissingImports
import qualified Curry_ModuleDeps
import qualified Curry_Names
import qualified Curry_Prelude
import qualified Curry_RCFile
import qualified Curry_ReadShowTerm
import qualified Curry_SimpleMake
import qualified Curry_System
import qualified Curry_TransFunctions
import qualified Curry_TransTypes
import qualified Curry_Utils


d_C_main :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_main cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_RCFile.d_C_readRC cd cs)
  d_OP_main_dot_uscore_hash_lambda1 cd cs

d_OP_main_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_System.d_C_getArgs cd cs)
  (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1) cd cs

d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_CompilerOpts.d_C_getCompilerOpts cd cs)
  (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
  x2 x1) cd cs

d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  Curry_CompilerOpts.C_Options (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_mapIO_ (d_C_build (d_C__case_33 x1 x2 x4 cd cs)) cd cs)
    x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
    x1 x2 l cd cs)
    (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
    x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
    x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.main._#lambda1._#lambda2._#lambda3" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "Compile.main._#lambda1._#lambda2._#lambda3"
    (showCons x3))

d_C_build :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_build x1 x2 cd cs = let x3 = d_C__case_32 x1
                              (Curry_TransFunctions.d_C_defaultState cd cs) cd
                              cs
  in Curry_Prelude.d_OP_gt_gt_eq (d_C_locateCurryFile x2 cd cs)
  (d_OP_build_dot_uscore_hash_lambda27 x3 x2 x1) cd cs

d_OP_build_dot_uscore_hash_lambda27 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar
    Curry_Message.d_C_putErrLn (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not find module ") x2 cd cs) cd cs
  Curry_Prelude.C_Just x5 -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_ModuleDeps.d_C_deps x3 x2 x5 cd cs)
    (d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 l cd cs)
    (d_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Compile.build._#lambda27" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.build._#lambda27" (showCons x4))

nd_OP_build_dot_uscore_hash_lambda27 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Message.d_C_putErrLn) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not find module ") x2 cd cs) s0 cd cs
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (Curry_ModuleDeps.d_C_deps x3 x2 x5
    cd cs) (wrapNX id
    (nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1)) s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 l s cd cs)
    (nd_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_build_dot_uscore_hash_lambda27 x1 x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Compile.build._#lambda27" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.build._#lambda27" (showCons x4))

d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_31 x4 x3 x1 (Curry_Prelude.d_C_null
    x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 l cd cs)
    (d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.build._#lambda27._#lambda29" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.build._#lambda27._#lambda29" (showCons
    x2))

nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_31 x4 x3 x1 (Curry_Prelude.d_C_null x4 cd cs) s0 cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 l s cd cs)
    (nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_build_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.build._#lambda27._#lambda29" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.build._#lambda27._#lambda29" (showCons
    x2))

d_C_locateCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_locateCurryFile x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1) cd cs

d_OP_locateCurryFile_dot_uscore_hash_lambda30 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Distribution.d_C_lookupModuleSourceInLoadPath
    (Curry_Distribution.d_C_stripCurrySuffix x1 cd cs) cd cs)
    (Curry_Prelude.d_C_maybe (Curry_Distribution.d_C_lookupFileInLoadPath
    (Curry_FlatCurry.d_C_flatCurryFileName x1 cd cs) cd cs)
    d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1 l cd cs)
    (d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_locateCurryFile_dot_uscore_hash_lambda30 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Compile.locateCurryFile._#lambda30" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.locateCurryFile._#lambda30" (showCons x2))

d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_C_return
    (Curry_Prelude.C_Just x3) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31 l cd
    cs) (d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_locateCurryFile_dot_uscore_hash_lambda30_dot_uscore_hash_lambda31 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.locateCurryFile._#lambda30._#lambda31" [show x1] info)
  _ -> failCons cd (consFail "Compile.locateCurryFile._#lambda30._#lambda31"
    (showCons x1))

d_C_makeModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C_makeModule x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_30 x1 x2 x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_makeModule x1 x2 l
    cd cs) (d_C_makeModule x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_makeModule
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_makeModule x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.makeModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.makeModule" (showCons x3))

nd_C_makeModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C_makeModule x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_30 x1 x2 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_makeModule x1 x2 l
    s cd cs) (nd_C_makeModule x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_makeModule x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_makeModule x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.makeModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.makeModule" (showCons x3))

d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps :: Curry_FlatCurry.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x3
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps l cd cs)
    (d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.makeModule._#selFP2#imps" [show x1] info)
  _ -> failCons cd (consFail "Compile.makeModule._#selFP2#imps" (showCons x1))

d_OP_makeModule_dot_uscore_hash_lambda32 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_makeModule_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5 x6 cd cs =
  let x7 = Curry_Prelude.OP_Cons x2 (d_C__case_26 x1 x6 cd cs)
      x8 = Curry_Prelude.d_C_map
        (d_OP_makeModule_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 x4
        x5) x3 cd cs
  in Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
  (Curry_Prelude.d_OP_plus_plus x7 x8 cd cs) cd cs

d_OP_makeModule_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_makeModule_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_dollar (Curry_Names.d_C_destFile
  (Curry_CompilerOpts.d_C_optTraceFailure x2 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x2 cd cs) x3)
  (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_fst (Curry_Prelude.d_OP_dollar
  Curry_Maybe.d_C_fromJust (Curry_Prelude.d_C_lookup x3 x1 cd cs) cd cs) cd cs)
  cd cs

d_OP_makeModule_dot_uscore_hash_lambda36 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
d_OP_makeModule_dot_uscore_hash_lambda36 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_25 x2 x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_makeModule_dot_uscore_hash_lambda36 l x2 cd cs)
    (d_OP_makeModule_dot_uscore_hash_lambda36 r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_makeModule_dot_uscore_hash_lambda36 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_makeModule_dot_uscore_hash_lambda36 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.makeModule._#lambda36" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.makeModule._#lambda36" (showCons x1))

d_OP_makeModule_dot_uscore_hash_lambda38 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_makeModule_dot_uscore_hash_lambda38 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  Curry_SimpleMake.d_C_smake (Curry_Names.d_C_destFile
  (Curry_CompilerOpts.d_C_optTraceFailure x5 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x5 cd cs) x2 x1 cd cs) x8
  (d_C_compileModule x6 x4 x7 x3 cd cs) (d_C_loadAnalysis x4 x7 x3 cd cs) cd cs

nd_OP_makeModule_dot_uscore_hash_lambda38 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_OP_makeModule_dot_uscore_hash_lambda38 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs =
  let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_SimpleMake.nd_C_smake
  (Curry_Names.d_C_destFile (Curry_CompilerOpts.d_C_optTraceFailure x5 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x5 cd cs) x2 x1 cd cs) x8
  (nd_C_compileModule x6 x4 x7 x3 s0 cd cs) (nd_C_loadAnalysis x4 x7 x3 s1 cd
  cs) s2 cd cs))))

d_C_writeAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeAnalysis x1 x2 x3 x4 cd cs = let x5 = Curry_Names.d_C_analysisFile
                                            (Curry_CompilerOpts.d_C_optOutputSubdir
                                            x1 cd cs) x2 x3 cd cs
  in Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
  (Curry_Message.d_C_showDetail x1) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Writing Analysis file ") x5 cd cs) cd cs)
  (Curry_Files.d_C_writeQTermFileInDir x5 (Curry_Analysis.d_C_showAnalysisResult
  x4 cd cs) cd cs) cd cs

nd_C_writeAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_writeAnalysis x1 x2 x3 x4 s cd cs = let s3 = s
  in s3 `seq` (let x5 = Curry_Names.d_C_analysisFile
                     (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x2 x3 cd
                     cs
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing Analysis file ") x5 cd cs) s0 cd cs)
  (Curry_Files.d_C_writeQTermFileInDir x5
  (Curry_Analysis.nd_C_showAnalysisResult x4 s1 cd cs) cd cs) s2 cd cs))))

d_C_readAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))
d_C_readAnalysis x1 x2 x3 cd cs = let x4 = Curry_Names.d_C_analysisFile
                                        (Curry_CompilerOpts.d_C_optOutputSubdir
                                        x1 cd cs) x2 x3 cd cs
  in Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
  (Curry_Message.d_C_showDetail x1) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Reading Analysis file ") x4 cd cs) cd cs)
  (Curry_Prelude.d_C_liftIO Curry_Analysis.d_C_readAnalysisResult
  (Curry_ReadShowTerm.d_C_readQTermFile x4 cd cs) cd cs) cd cs

nd_C_readAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))
nd_C_readAnalysis x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let x4 = Curry_Names.d_C_analysisFile
                     (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x2 x3 cd
                     cs
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Reading Analysis file ") x4 cd cs) s0 cd cs) (Curry_Prelude.nd_C_liftIO
  (wrapNX id Curry_Analysis.nd_C_readAnalysisResult)
  (Curry_ReadShowTerm.d_C_readQTermFile x4 cd cs) s1 cd cs) s2 cd cs))))

d_C_loadAnalysis :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C_loadAnalysis x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_24 x2 x1 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_loadAnalysis x1 x2 l
    cd cs) (d_C_loadAnalysis x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_loadAnalysis x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_loadAnalysis x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.loadAnalysis" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis" (showCons x3))

nd_C_loadAnalysis :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C_loadAnalysis x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_24 x2 x1 x5 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_loadAnalysis x1 x2
    l s cd cs) (nd_C_loadAnalysis x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_loadAnalysis x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_loadAnalysis x1 x2
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.loadAnalysis" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis" (showCons x3))

d_OP_loadAnalysis_dot_uscore_hash_lambda39 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple5 x3 x4 x5 x6 x7 -> Curry_Prelude.d_C_return
    (d_C__case_22 x7 x6 x5 x4 x3 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple5 d i l r -> narrow d i
    (d_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 l cd cs)
    (d_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple5 d i xs -> narrows cs d i (\z ->
    d_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple5 d c e -> guardCons d c
    (d_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple5 d info -> failCons d (traceFail
    "Compile.loadAnalysis._#lambda39" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis._#lambda39" (showCons x2))

nd_OP_loadAnalysis_dot_uscore_hash_lambda39 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple5 x3 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_C_return (nd_C__case_22 x7 x6 x5 x4 x3 x1 s0 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple5 d i l r -> narrow d i
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 l s cd cs)
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple5 d i xs -> narrows cs d i (\z ->
    nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple5 d c e -> guardCons d c
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple5 d info -> failCons d (traceFail
    "Compile.loadAnalysis._#lambda39" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis._#lambda39" (showCons x2))

d_C_compileModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
  -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C_compileModule x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_21 x3 x1 x2 x6 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_compileModule x1 x2
    x3 l cd cs) (d_C_compileModule x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_compileModule x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_compileModule x1 x2
    x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.compileModule" (showCons x4))

nd_C_compileModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
  -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C_compileModule x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_21 x3 x1 x2 x6 x5 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_compileModule x1 x2
    x3 l s cd cs) (nd_C_compileModule x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_compileModule x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_compileModule x1 x2
    x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.compileModule" (showCons x4))

d_OP_compileModule_dot_fcyFile_dot_56 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_compileModule_dot_fcyFile_dot_56 x1 cd cs = Curry_Files.d_C_withExtension
  (Curry_Prelude.d_C_const (Curry_Prelude.toCurryString ".fcy")) x1 cd cs

d_OP_compileModule_dot_ahsFile_dot_56 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_compileModule_dot_ahsFile_dot_56 x1 cd cs = Curry_Files.d_C_withExtension
  (Curry_Prelude.d_C_const (Curry_Prelude.toCurryString ".ahs")) x1 cd cs

d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed :: Curry_FlatCurry.C_Prog
  -> Cover -> ConstStore -> Curry_FlatCurry.C_Prog
d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x1
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed l cd cs)
    (d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.compileModule._#selFP12#renamed" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#selFP12#renamed" (showCons
    x1))

d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts :: Curry_FlatCurry.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl
d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x4
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts l cd cs)
    (d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.compileModule._#selFP13#ts" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#selFP13#ts" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda49 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  let x11 = Curry_Prelude.d_C_either Curry_Prelude.d_C_error
        Curry_Prelude.d_C_id x10 cd cs
      x12 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
        x11 cd cs
      x13 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n
        x11 cd cs
      x14 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
        x11 cd cs
      x15 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
        x11 cd cs
      x16 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
        x11 cd cs
      x17 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
        x11 cd cs
      x18 = d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
        x11 cd cs
  in Curry_Prelude.d_OP_gt_gt (d_C_writeAnalysis
  (Curry_TransFunctions.d_C_compOptions x18 cd cs) x6 x3 x17 cd cs)
  (Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpFunDecls x7 x4
  (Curry_Prelude.d_C_show x12 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Transforming type declarations") cd cs) (let x19 = Curry_Prelude.d_C_apply
                                                  (Curry_TransTypes.d_C_transTypes
                                                  (Curry_TransFunctions.d_C_hoResultCons
                                                  x18 cd cs) cd cs) x8 cd cs
  in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpTypeDecls x7 x9
  (Curry_Prelude.d_C_show x19 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Combining to Abstract Haskell") cd cs)
  (let x20 = Curry_AbstractHaskell.C_Prog x13 (Curry_Prelude.d_OP_plus_plus
         (d_C_defaultModules cd cs) x14 cd cs) x19 x15 x16
       x21 = d_C_patchPreludeExports x20 cd cs
  in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpTranslated x7
  x1 (Curry_Prelude.d_C_show x21 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Integrating external declarations") cd cs) (Curry_Prelude.d_OP_gt_gt_eq
  (d_C_integrateExternals x7 x21 x3 cd cs)
  (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 x2 x5
  x15 x7 x18) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_compileModule_dot_uscore_hash_lambda49 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda49 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s33 = s
  in s33 `seq` (let s34 = leftSupply s33
                    s37 = rightSupply s33
                    s35 = leftSupply s34
                    s36 = rightSupply s34
                    s0 = leftSupply s35
                    s1 = rightSupply s35
                    s2 = leftSupply s36
                    s3 = rightSupply s36
                    s38 = leftSupply s37
                    s39 = rightSupply s37
                    s4 = leftSupply s38
                    s5 = rightSupply s38
                    s6 = leftSupply s39
                    s40 = rightSupply s39
                    s7 = leftSupply s40
                    s31 = rightSupply s40
  in s34 `seq` (s37 `seq` (s35 `seq` (s36 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  (s3 `seq` (s38 `seq` (s39 `seq` (s4 `seq` (s5 `seq` (s6 `seq` (s40 `seq`
  (s7 `seq` (s31 `seq` (let x11 = Curry_Prelude.nd_C_either (wrapDX id
                              Curry_Prelude.d_C_error) (wrapDX id
                              Curry_Prelude.d_C_id) x10 s0 cd cs
                            x12 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
                              x11 s1 cd cs
                            x13 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n
                              x11 s2 cd cs
                            x14 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
                              x11 s3 cd cs
                            x15 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
                              x11 s4 cd cs
                            x16 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
                              x11 s5 cd cs
                            x17 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
                              x11 s6 cd cs
                            x18 = nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
                              x11 s7 cd cs
  in let s30 = leftSupply s31
         s32 = rightSupply s31
         s10 = leftSupply s32
         s29 = rightSupply s32
  in s30 `seq` (s32 `seq` (s10 `seq` (s29 `seq` Curry_Prelude.nd_OP_gt_gt
  (let s9 = leftSupply s10
       s8 = rightSupply s10
  in s9 `seq` (s8 `seq` nd_C_writeAnalysis
  (Curry_TransFunctions.nd_C_compOptions x18 s8 cd cs) x6 x3 x17 s9 cd cs))
  (let s28 = leftSupply s29
       s27 = rightSupply s29
  in s28 `seq` (s27 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
  Curry_CompilerOpts.C_DumpFunDecls x7 x4 (Curry_Prelude.d_C_show x12 cd cs) cd
  cs) (let s26 = leftSupply s27
           s25 = rightSupply s27
  in s26 `seq` (s25 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Transforming type declarations") cd cs) (let s15 = leftSupply s25
                                                s24 = rightSupply s25
  in s15 `seq` (s24 `seq` (let x19 = let s14 = leftSupply s15
                                         s13 = rightSupply s15
                                 in s14 `seq` (s13 `seq`
                                 Curry_Prelude.nd_C_apply (let s12 = leftSupply
                                                                 s13
                                                               s11 = rightSupply
                                                                 s13
                                 in s12 `seq` (s11 `seq`
                                 Curry_TransTypes.nd_C_transTypes
                                 (Curry_TransFunctions.nd_C_hoResultCons x18 s11
                                 cd cs) s12 cd cs)) x8 s14 cd cs)
  in let s23 = leftSupply s24
         s22 = rightSupply s24
  in s23 `seq` (s22 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
  Curry_CompilerOpts.C_DumpTypeDecls x7 x9 (Curry_Prelude.d_C_show x19 cd cs) cd
  cs) (let s21 = leftSupply s22
           s20 = rightSupply s22
  in s21 `seq` (s20 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Combining to Abstract Haskell") cd cs)
  (let x20 = Curry_AbstractHaskell.C_Prog x13 (Curry_Prelude.d_OP_plus_plus
         (d_C_defaultModules cd cs) x14 cd cs) x19 x15 x16
       x21 = d_C_patchPreludeExports x20 cd cs
  in let s19 = leftSupply s20
         s18 = rightSupply s20
  in s19 `seq` (s18 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
  Curry_CompilerOpts.C_DumpTranslated x7 x1 (Curry_Prelude.d_C_show x21 cd cs)
  cd cs) (let s17 = leftSupply s18
              s16 = rightSupply s18
  in s17 `seq` (s16 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Message.d_C_showDetail x7 (Curry_Prelude.toCurryString
  "Integrating external declarations") cd cs) (Curry_Prelude.nd_OP_gt_gt_eq
  (d_C_integrateExternals x7 x21 x3 cd cs) (wrapNX id
  (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 x2 x5
  x15 x7 x18)) s16 cd cs) s17 cd cs)) s19 cd cs)) s21 cd cs)) s23 cd cs)))) s26
  cd cs)) s28 cd cs)) s30 cd cs))))))))))))))))))))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_19 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP5#ahsFun" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP5#ahsFun"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Prog
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_19 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP5_hash_ahsFun
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP5#ahsFun" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP5#ahsFun"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_17 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n l
    cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP6#n" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP6#n"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_17 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP6_hash_n
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP6#n" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP6#n"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_15 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP7#imps" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP7#imps"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_15 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP7_hash_imps
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP7#imps" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP7#imps"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_13 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP8#funs" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP8#funs"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_13 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP8_hash_funs
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP8#funs" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP8#funs"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_11 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP9#ops" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP9#ops"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_11 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP9_hash_ops
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP9#ops" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP9#ops"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_9 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP10#modAnalysisResult" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda49._#selFP10#modAnalysisResult" (showCons
    x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_9 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP10_hash_modAnalysisResult
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP10#modAnalysisResult" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda49._#selFP10#modAnalysisResult" (showCons
    x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_7 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP11#state'" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP11#state'"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_7 x3 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_selFP11_hash_state_tick
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda49._#selFP11#state'" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda49._#selFP11#state'"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
  -> Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
  (Curry_Message.d_C_showDetail x4) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Generating Haskell module ") x1 cd cs) cd cs)
  (Curry_Prelude.d_OP_gt_gt (Curry_Files.d_C_writeFileInDir x1 x6 cd cs)
  (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
  (Curry_Message.d_C_showDetail x4) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Writing auxiliary info file ") x2 cd cs) cd cs)
  (Curry_Prelude.d_OP_gt_gt (Curry_Files.d_C_writeQTermFileInDir x2
  (d_C_extractFuncInfos x3 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x4)
  (Curry_Prelude.toCurryString "Done") cd cs) (Curry_Prelude.d_C_return x5 cd
  cs) cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
  -> Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda49_dot_uscore_hash_lambda50 x1 x2 x3 x4 x5 x6 s cd cs =
  let s13 = s
  in s13 `seq` (let s12 = leftSupply s13
                    s14 = rightSupply s13
                    s0 = leftSupply s14
                    s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s0 `seq` (s11 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x4))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Generating Haskell module ") x1 cd cs) s0 cd cs) (let s10 = leftSupply s11
                                                         s8 = rightSupply s11
  in s10 `seq` (s8 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Files.d_C_writeFileInDir x1 x6 cd cs) (let s7 = leftSupply s8
                                                    s9 = rightSupply s8
                                                    s1 = leftSupply s9
                                                    s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s1 `seq` (s6 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x4))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing auxiliary info file ") x2 cd cs) s1 cd cs) (let s5 = leftSupply s6
                                                           s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_OP_gt_gt
  (Curry_Files.d_C_writeQTermFileInDir x2 (d_C_extractFuncInfos x3 cd cs) cd cs)
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_gt_gt (Curry_Prelude.nd_OP_dollar
  (wrapDX id (Curry_Message.d_C_showDetail x4)) (Curry_Prelude.toCurryString
  "Done") s2 cd cs) (Curry_Prelude.d_C_return x5 cd cs) s3 cd cs)) s5 cd cs)) s7
  cd cs)))) s10 cd cs)) s12 cd cs))))

d_C_extractFuncInfos :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Prelude.C_Bool)
d_C_extractFuncInfos x1 cd cs = Curry_Prelude.d_C_map
  d_OP_extractFuncInfos_dot_uscore_hash_lambda51 x1 cd cs

d_OP_extractFuncInfos_dot_withIOResult_dot_104 :: Curry_AbstractHaskell.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_withIOResult_dot_104 x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_TVar x2 -> Curry_Prelude.C_False
  Curry_AbstractHaskell.C_FuncType x3 x4 -> d_OP_extractFuncInfos_dot_withIOResult_dot_104
    x4 cd cs
  Curry_AbstractHaskell.C_TCons x5 x6 -> Curry_Prelude.d_OP_eq_eq x5
    (Curry_Prelude.OP_Tuple2 (Curry_Names.d_C_curryPrelude cd cs)
    (Curry_Prelude.toCurryString "C_IO")) cd cs
  Curry_AbstractHaskell.Choice_C_TypeExpr d i l r -> narrow d i
    (d_OP_extractFuncInfos_dot_withIOResult_dot_104 l cd cs)
    (d_OP_extractFuncInfos_dot_withIOResult_dot_104 r cd cs)
  Curry_AbstractHaskell.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_OP_extractFuncInfos_dot_withIOResult_dot_104 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_TypeExpr d c e -> guardCons d c
    (d_OP_extractFuncInfos_dot_withIOResult_dot_104 e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_TypeExpr d info -> failCons d (traceFail
    "Compile.extractFuncInfos.withIOResult.104" [show x1] info)
  _ -> failCons cd (consFail "Compile.extractFuncInfos.withIOResult.104"
    (showCons x1))

d_OP_extractFuncInfos_dot_isIO_dot_104 :: Curry_AbstractHaskell.C_TypeSig
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_isIO_dot_104 x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_Untyped -> Curry_Prelude.C_False
  Curry_AbstractHaskell.C_FType x2 -> d_OP_extractFuncInfos_dot_withIOResult_dot_104
    x2 cd cs
  Curry_AbstractHaskell.C_CType x3 x4 -> d_OP_extractFuncInfos_dot_withIOResult_dot_104
    x4 cd cs
  Curry_AbstractHaskell.Choice_C_TypeSig d i l r -> narrow d i
    (d_OP_extractFuncInfos_dot_isIO_dot_104 l cd cs)
    (d_OP_extractFuncInfos_dot_isIO_dot_104 r cd cs)
  Curry_AbstractHaskell.Choices_C_TypeSig d i xs -> narrows cs d i (\z ->
    d_OP_extractFuncInfos_dot_isIO_dot_104 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_TypeSig d c e -> guardCons d c
    (d_OP_extractFuncInfos_dot_isIO_dot_104 e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_TypeSig d info -> failCons d (traceFail
    "Compile.extractFuncInfos.isIO.104" [show x1] info)
  _ -> failCons cd (consFail "Compile.extractFuncInfos.isIO.104" (showCons x1))

d_OP_extractFuncInfos_dot_uscore_hash_lambda51 :: Curry_AbstractHaskell.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_uscore_hash_lambda51 x1 cd cs =
  Curry_Prelude.OP_Tuple2 (Curry_AbstractHaskellGoodies.d_C_funcName x1 cd cs)
  (d_OP_extractFuncInfos_dot_isIO_dot_104
  (Curry_AbstractHaskellGoodies.d_C_typeOf x1 cd cs) cd cs)

d_C_patchPreludeExports :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C_patchPreludeExports x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_Prog x2 x3 x4 x5 x6 -> let x7 = Curry_AbstractHaskell.C_Type
                                                       (Curry_Prelude.OP_Tuple2
                                                       (Curry_Names.d_C_curryPrelude
                                                       cd cs)
                                                       (Curry_Prelude.toCurryString
                                                       "Curry"))
                                                       Curry_AbstractHaskell.C_Public
                                                       Curry_Prelude.OP_List
                                                       Curry_Prelude.OP_List
                                                     x8 = Curry_AbstractHaskell.C_Func
                                                       Curry_Prelude.OP_List
                                                       (Curry_Prelude.OP_Tuple2
                                                       (Curry_Names.d_C_curryPrelude
                                                       cd cs)
                                                       (Curry_Prelude.toCurryString
                                                       "toCurryString"))
                                                       (Curry_Prelude.C_Int 1#)
                                                       Curry_AbstractHaskell.C_Public
                                                       Curry_AbstractHaskell.C_Untyped
                                                       Curry_AbstractHaskell.C_External
    in d_C__case_5 x2 x1 x6 x5 x8 x4 x7 x3 (Curry_Prelude.d_OP_eq_eq x2
    (Curry_Names.d_C_curryPrelude cd cs) cd cs) cd cs
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i
    (d_C_patchPreludeExports l cd cs) (d_C_patchPreludeExports r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_patchPreludeExports z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c
    (d_C_patchPreludeExports e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.patchPreludeExports" [show x1] info)
  _ -> failCons cd (consFail "Compile.patchPreludeExports" (showCons x1))

d_C_compMessage :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_compMessage x1 x2 x3 x4 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_3 x6 x3 x2 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_compMessage l x2 x3
    x4 cd cs) (d_C_compMessage r x2 x3 x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_compMessage z x2 x3 x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_compMessage e x2 x3
    x4 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compMessage" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.compMessage" (showCons x1))

d_C_filterPrelude :: Curry_CompilerOpts.C_Options -> Curry_FlatCurry.C_Prog
  -> Cover -> ConstStore -> Curry_FlatCurry.C_Prog
d_C_filterPrelude x1 x2 cd cs = case x2 of
  Curry_FlatCurry.C_Prog x3 x4 x5 x6 x7 -> let x8 = Curry_Prelude.d_C_apply
                                                 (Curry_Prelude.d_C_elem
                                                 Curry_CompilerOpts.C_NoImplicitPrelude
                                                 cd cs)
                                                 (Curry_CompilerOpts.d_C_optExtensions
                                                 x1 cd cs) cd cs
    in d_C__case_2 x2 x7 x6 x5 x4 x3 x8 cd cs
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i (d_C_filterPrelude x1 l cd
    cs) (d_C_filterPrelude x1 r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_filterPrelude x1 z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c (d_C_filterPrelude x1 e
    cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.filterPrelude" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.filterPrelude" (showCons x2))

d_C_integrateExternals :: Curry_CompilerOpts.C_Options
  -> Curry_AbstractHaskell.C_Prog -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_integrateExternals x1 x2 x3 cd cs = case x2 of
  Curry_AbstractHaskell.C_Prog x4 x5 x6 x7 x8 -> let x9 = Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# LANGUAGE MagicHash #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}")
                                                       Curry_Prelude.OP_List)
                                                     x10 = d_C__case_0 x1 x4
                                                       (Curry_AbstractHaskellPrinter.d_C_defaultOptions
                                                       cd cs) cd cs
    in Curry_Prelude.d_OP_gt_gt_eq (d_C_lookupExternals x1
    (Curry_Prelude.d_C_apply (Curry_FilePath.d_C_dropExtension cd cs) x3 cd cs)
    cd cs) (d_OP_integrateExternals_dot_uscore_hash_lambda55 x9 x7 x5 x4 x8 x10
    x6) cd cs
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i
    (d_C_integrateExternals x1 l x3 cd cs) (d_C_integrateExternals x1 r x3 cd
    cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_integrateExternals x1 z x3 cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c
    (d_C_integrateExternals x1 e x3 cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.integrateExternals" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.integrateExternals" (showCons x2))

d_OP_integrateExternals_dot_uscore_hash_lambda55 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
  -> Curry_AbstractHaskellPrinter.C_Options -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_TypeDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda55 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  let x9 = d_C_splitExternals x8 cd cs
      x10 = d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas
        x9 cd cs
      x11 = d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps
        x9 cd cs
      x12 = d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls
        x9 cd cs
  in Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
  (Curry_Prelude.d_OP_dollar (Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString "\n")) (Curry_Prelude.d_C_filter
  (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_unlines (Curry_Prelude.d_OP_plus_plus x1 x10 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs)
  (Curry_AbstractHaskellPrinter.d_C_ppHeader x6 x4 x7 x2 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs) (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_ppImports x6 cd cs) x3 cd cs) cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_unlines x11 cd cs) cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs)
  (Curry_AbstractHaskellPrinter.d_C_ppDecls x6 x5 x7 x2 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_unlines x12 cd cs) cd
  cs) Curry_Prelude.OP_List)))))) cd cs) cd cs) cd cs

d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP15_hash_pragmas
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda55._#selFP15#pragmas" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda55._#selFP15#pragmas" (showCons x1))

d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP16_hash_extimps
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda55._#selFP16#extimps" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda55._#selFP16#extimps" (showCons x1))

d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda55_dot_uscore_hash_selFP17_hash_extdecls
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda55._#selFP17#extdecls" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda55._#selFP17#extdecls" (showCons x1))

d_C_lookupExternals :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_lookupExternals x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                        (Curry_Names.d_C_externalFile cd cs) x2
                                        cd cs
  in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x3 cd cs)
  (d_OP_lookupExternals_dot_uscore_hash_lambda56 x3 x1) cd cs

d_OP_lookupExternals_dot_uscore_hash_lambda56 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_lookupExternals_dot_uscore_hash_lambda56 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Message.d_C_showDetail
    x2 (Curry_Prelude.toCurryString "External file found") cd cs)
    (Curry_Prelude.d_C_readFile x1 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x2 (Curry_Prelude.toCurryString
    "No external file found") cd cs) (Curry_Prelude.d_C_return
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_lookupExternals_dot_uscore_hash_lambda56 x1 x2 l cd cs)
    (d_OP_lookupExternals_dot_uscore_hash_lambda56 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_lookupExternals_dot_uscore_hash_lambda56 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_lookupExternals_dot_uscore_hash_lambda56 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Compile.lookupExternals._#lambda56" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.lookupExternals._#lambda56" (showCons x3))

d_C_splitExternals :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_splitExternals x1 cd cs = let x2 = Curry_Prelude.d_OP_dot
                                    (Curry_Prelude.d_C_reverse cd cs)
                                    (Curry_Prelude.d_OP_dot
                                    (Curry_Prelude.d_C_dropWhile
                                    (Curry_Prelude.d_C_all
                                    Curry_Char.d_C_isSpace cd cs))
                                    (Curry_Prelude.d_C_reverse cd cs) cd cs) cd
                                    cs
                                  x3 = Curry_Prelude.d_C_span
                                    d_OP_splitExternals_dot_isPragma_dot_147
                                    (Curry_Prelude.d_C_lines x1 cd cs) cd cs
                                  x4 = d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas
                                    x3 cd cs
                                  x5 = d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest
                                    x3 cd cs
                                  x6 = Curry_Prelude.d_C_span
                                    d_OP_splitExternals_dot_isImport_dot_147 x5
                                    cd cs
                                  x7 = d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports
                                    x6 cd cs
                                  x8 = d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls
                                    x6 cd cs
  in Curry_Prelude.OP_Tuple3 (Curry_Prelude.d_C_apply x2 x4 cd cs)
  (Curry_Prelude.d_C_apply x2 x7 cd cs) x8

d_OP_splitExternals_dot_isPragma_dot_147 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isPragma_dot_147 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs)
  x1 cd cs) (Curry_List.d_C_isPrefixOf (Curry_Prelude.toCurryString "{-#") x1 cd
  cs) cd cs

d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP22_hash_pragmas e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP22#pragmas" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP22#pragmas"
    (showCons x1))

d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP23_hash_rest e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP23#rest" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP23#rest" (showCons
    x1))

d_OP_splitExternals_dot_isComment_dot_147 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isComment_dot_147 x1 cd cs = Curry_Prelude.d_OP_amp_amp
  (Curry_List.d_C_isPrefixOf (Curry_Prelude.toCurryString "-- ") x1 cd cs)
  (Curry_Prelude.d_C_not (Curry_List.d_C_isPrefixOf (Curry_Prelude.toCurryString
  "-- #endimport") x1 cd cs) cd cs) cd cs

d_OP_splitExternals_dot_isImport_dot_147 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isImport_dot_147 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs)
  x1 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.toCurryString "import") x1 cd cs) (Curry_Prelude.d_OP_bar_bar
  (Curry_List.d_C_isPrefixOf (Curry_Prelude.toCurryString "#") x1 cd cs)
  (d_OP_splitExternals_dot_isComment_dot_147 x1 cd cs) cd cs) cd cs) cd cs

d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_imports e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP20#imports" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP20#imports"
    (showCons x1))

d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_decls e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP21#decls" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP21#decls" (showCons
    x1))

d_C_dump :: Curry_CompilerOpts.C_DumpFormat -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_dump x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_when
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x1 cd cs)
  (Curry_CompilerOpts.d_C_optDump x2 cd cs) cd cs)) (Curry_Prelude.d_OP_gt_gt
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x2)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Dumping ") x3 cd
  cs) cd cs) (Curry_Files.d_C_writeFileInDir (Curry_Files.d_C_withDirectory
  (Curry_Prelude.d_C_flip (Curry_FilePath.d_OP_lt_slash_gt cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x2 cd cs)) x3 cd cs) x4 cd cs) cd cs)
  cd cs

d_C_rename :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore
  -> Curry_FlatCurry.C_Prog
d_C_rename x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> let x7 = Curry_Prelude.d_C_apply
                                                 (Curry_FlatCurryGoodies.d_C_updQNamesInProg
                                                 (Curry_Names.d_C_renameQName cd
                                                 cs) cd cs) x1 cd cs
                                               x8 = d_OP_rename_dot_uscore_hash_selFP25_hash_td
                                                 x7 cd cs
                                               x9 = d_OP_rename_dot_uscore_hash_selFP26_hash_fd
                                                 x7 cd cs
                                               x10 = d_OP_rename_dot_uscore_hash_selFP27_hash_od
                                                 x7 cd cs
    in Curry_FlatCurry.C_Prog (Curry_Prelude.d_C_apply
    (Curry_Names.d_C_renameModule cd cs) x2 cd cs) (Curry_Prelude.d_C_map
    (Curry_Names.d_C_renameModule cd cs) x3 cd cs) x8 x9 x10
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i (d_C_rename l cd cs)
    (d_C_rename r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z -> d_C_rename z cd
    cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c (d_C_rename e cd $! addCs
    c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail "Compile.rename"
    [show x1] info)
  _ -> failCons cd (consFail "Compile.rename" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP25_hash_td :: Curry_FlatCurry.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl
d_OP_rename_dot_uscore_hash_selFP25_hash_td x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x4
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP25_hash_td l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP25_hash_td r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP25_hash_td z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP25_hash_td e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP25#td" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP25#td" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP26_hash_fd :: Curry_FlatCurry.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl
d_OP_rename_dot_uscore_hash_selFP26_hash_fd x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x5
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP26_hash_fd l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP26_hash_fd r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP26_hash_fd z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP26_hash_fd e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP26#fd" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP26#fd" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP27_hash_od :: Curry_FlatCurry.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_OpDecl
d_OP_rename_dot_uscore_hash_selFP27_hash_od x1 cd cs = case x1 of
  Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6 -> x6
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP27_hash_od l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP27_hash_od r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP27_hash_od z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP27_hash_od e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP27#od" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP27#od" (showCons x1))

d_C_defaultModules :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_defaultModules cd cs = Curry_Prelude.OP_Cons (Curry_Names.d_C_basics cd cs)
  Curry_Prelude.OP_List

d_C__case_0 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_AbstractHaskellPrinter.C_Options -> Cover
  -> ConstStore -> Curry_AbstractHaskellPrinter.C_Options
d_C__case_0 x1 x4 x13 cd cs = case x13 of
  Curry_AbstractHaskellPrinter.C_Options x11 x12 -> Curry_AbstractHaskellPrinter.C_Options
    x4 (Curry_CompilerOpts.d_C_optTraceFailure x1 cd cs)
  Curry_AbstractHaskellPrinter.Choice_C_Options d i l r -> narrow d i
    (d_C__case_0 x1 x4 l cd cs) (d_C__case_0 x1 x4 r cd cs)
  Curry_AbstractHaskellPrinter.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_0 x1 x4 z cd cs) xs
  Curry_AbstractHaskellPrinter.Guard_C_Options d c e -> guardCons d c
    (d_C__case_0 x1 x4 e cd $! addCs c cs)
  Curry_AbstractHaskellPrinter.Fail_C_Options d info -> failCons d (traceFail
    "Compile._case_0" [show x1, show x4, show x13] info)
  _ -> failCons cd (consFail "Compile._case_0" (showCons x13))

d_C__case_2 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List
  Curry_FlatCurry.C_OpDecl -> Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl
  -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_FlatCurry.C_Prog
d_C__case_2 x2 x7 x6 x5 x4 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_FlatCurry.C_Prog x3 (Curry_Prelude.d_C_filter
    (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_slash_eq)
    (Curry_Names.d_C_prelude cd cs)) x4 cd cs) x5 x6 x7
  Curry_Prelude.C_False -> d_C__case_1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x7 x6 x5 x4
    x3 l cd cs) (d_C__case_2 x2 x7 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x7
    x6 x5 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x2 x7 x6 x5 x4
    x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_2"
    [show x2, show x7, show x6, show x5, show x4, show x3, show x8] info)
  _ -> failCons cd (consFail "Compile._case_2" (showCons x8))

d_C__case_1 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_FlatCurry.C_Prog
d_C__case_1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 l cd cs)
    (d_C__case_1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_1"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "Compile._case_1" (showCons x3))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x6 x3 x2 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let x9 = Curry_Prelude.d_C_show x6 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_lpad
    (Curry_Prelude.d_C_length x9 cd cs) (Curry_Prelude.d_C_show x5 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " of ")
    (Curry_Prelude.d_OP_plus_plus x9 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "]") (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char ' '#) (Curry_Prelude.d_OP_plus_plus
    (Curry_Utils.d_C_rpad (Curry_Prelude.C_Int 9#) x2 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_rpad (Curry_Prelude.C_Int
    16#) x3 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ( ") (Curry_Prelude.d_OP_plus_plus (Curry_FilePath.d_C_normalise x7 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ", ")
    (Curry_Prelude.d_OP_plus_plus (Curry_FilePath.d_C_normalise x8 cd cs)
    (Curry_Prelude.toCurryString " )") cd cs) cd cs) cd cs) cd cs) cd cs)) cd
    cs)) cd cs) cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 x6 x3 x2 x5
    l cd cs) (d_C__case_3 x6 x3 x2 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 x6
    x3 x2 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_3 x6 x3 x2 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_3"
    [show x6, show x3, show x2, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_3" (showCons x4))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_AbstractHaskell.C_Prog -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_OpDecl -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl -> Curry_AbstractHaskell.C_FuncDecl
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeDecl
  -> Curry_AbstractHaskell.C_TypeDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_C__case_5 x2 x1 x6 x5 x8 x4 x7 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_AbstractHaskell.C_Prog x2 x3
    (Curry_Prelude.OP_Cons x7 x4) (Curry_Prelude.OP_Cons x8 x5) x6
  Curry_Prelude.C_False -> d_C__case_4 x1 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x2 x1 x6 x5 x8
    x4 x7 x3 l cd cs) (d_C__case_5 x2 x1 x6 x5 x8 x4 x7 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x2 x1
    x6 x5 x8 x4 x7 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x2 x1 x6 x5 x8
    x4 x7 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_5"
    [show x2, show x1, show x6, show x5, show x8, show x4, show x7, show x3
    , show x9] info)
  _ -> failCons cd (consFail "Compile._case_5" (showCons x9))

d_C__case_4 :: Curry_AbstractHaskell.C_Prog -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_C__case_4 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x1 l cd cs)
    (d_C__case_4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile._case_4" (showCons x2))

d_C__case_7 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_TransFunctions.C_State
d_C__case_7 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_6 x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x3 l cd cs)
    (d_C__case_7 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_7 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_7"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Compile._case_7" (showCons x2))

nd_C__case_7 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_TransFunctions.C_State
nd_C__case_7 x3 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_6 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_7 x3 l s cd
    cs) (nd_C__case_7 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_7
    x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_7 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_7"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Compile._case_7" (showCons x2))

d_C__case_6 :: Curry_TransFunctions.C_State -> Curry_AbstractHaskell.C_Prog
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_6 x3 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x3
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_6 x3 l cd
    cs) (d_C__case_6 x3 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_6 x3 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_6 x3 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_6" [show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_6" (showCons x4))

nd_C__case_6 :: Curry_TransFunctions.C_State -> Curry_AbstractHaskell.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_6 x3 x4 s cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x3
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (nd_C__case_6 x3 l s
    cd cs) (nd_C__case_6 x3 r s cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C__case_6 x3 z s cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (nd_C__case_6 x3 e s
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_6" [show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_6" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_C__case_9 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_8 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_9 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Compile._case_9" (showCons x2))

nd_C__case_9 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_C__case_9 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_8 x5 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_9 l s cd cs)
    (nd_C__case_9 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_9 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_9 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Compile._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Curry_AbstractHaskell.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_C__case_8 x5 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x5
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_8 x5 l cd
    cs) (d_C__case_8 x5 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_8 x5 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_8 x5 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_8" [show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_8" (showCons x4))

nd_C__case_8 :: Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Curry_AbstractHaskell.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_C__case_8 x5 x4 s cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x5
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (nd_C__case_8 x5 l s
    cd cs) (nd_C__case_8 x5 r s cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C__case_8 x5 z s cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (nd_C__case_8 x5 e s
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_8" [show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_8" (showCons x4))

d_C__case_11 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_C__case_11 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_10 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_11 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_11" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_11" (showCons x2))

nd_C__case_11 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
nd_C__case_11 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_10 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_11 l s cd cs)
    (nd_C__case_11 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_11
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_11 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_11" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_11" (showCons x2))

d_C__case_10 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_C__case_10 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x10
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_10 l cd
    cs) (d_C__case_10 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_10 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_10 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_10" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_10" (showCons x4))

d_C__case_13 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_C__case_13 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_12 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_13 l cd cs)
    (d_C__case_13 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_13 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_13 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_13" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_13" (showCons x2))

nd_C__case_13 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
nd_C__case_13 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_12 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_13 l s cd cs)
    (nd_C__case_13 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_13
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_13 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_13" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_13" (showCons x2))

d_C__case_12 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_C__case_12 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x9
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_12 l cd
    cs) (d_C__case_12 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_12 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_12 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_12" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_12" (showCons x4))

d_C__case_15 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_15 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_14 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_15 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_15 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_15" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_15" (showCons x2))

nd_C__case_15 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_15 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_14 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_15 l s cd cs)
    (nd_C__case_15 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_15
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_15 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_15" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_15" (showCons x2))

d_C__case_14 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_14 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x7
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_14 l cd
    cs) (d_C__case_14 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_14 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_14 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_14" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_14" (showCons x4))

d_C__case_17 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_17 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_16 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_17 l cd cs)
    (d_C__case_17 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_17 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_17 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_17" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_17" (showCons x2))

nd_C__case_17 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_17 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_16 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_17 l s cd cs)
    (nd_C__case_17 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_17
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_17 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_17" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_17" (showCons x2))

d_C__case_16 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_16 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x6
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_16 l cd
    cs) (d_C__case_16 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_16 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_16 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_16" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_16" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C__case_19 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_18 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_19 l cd cs)
    (d_C__case_19 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_19 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_19 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_19" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_19" (showCons x2))

nd_C__case_19 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
nd_C__case_19 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_18 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_19 l s cd cs)
    (nd_C__case_19 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_19
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_19 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_19" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_19" (showCons x2))

d_C__case_18 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C__case_18 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x4
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_18 l cd
    cs) (d_C__case_18 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_18 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_18 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_18" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_18" (showCons x4))

d_C__case_21 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C__case_21 x3 x1 x2 x6 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> d_C__case_20 x7 x3 x1 x2 x6 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_21 x3 x1 x2 x6
    l cd cs) (d_C__case_21 x3 x1 x2 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_21
    x3 x1 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_21 x3 x1 x2 x6
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_21" [show x3, show x1, show x2, show x6, show x5] info)
  _ -> failCons cd (consFail "Compile._case_21" (showCons x5))

nd_C__case_21 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_21 x3 x1 x2 x6 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_20 x7 x3 x1 x2 x6 x8 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_21 x3 x1 x2
    x6 l s cd cs) (nd_C__case_21 x3 x1 x2 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_21
    x3 x1 x2 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_21 x3 x1 x2
    x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_21" [show x3, show x1, show x2, show x6, show x5] info)
  _ -> failCons cd (consFail "Compile._case_21" (showCons x5))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C__case_20 x7 x3 x1 x2 x6 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let x11 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString "Dump"))
                                          x7 cd cs) cd cs
                                        x12 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString "Typed"))
                                          x7 cd cs) cd cs
                                        x13 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "ExtImports")) x7 cd cs) cd cs
                                        x14 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "Lifted")) x7 cd cs) cd cs
                                        x15 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "ElimCond")) x7 cd cs) cd cs
                                        x16 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "Defaulted")) x7 cd cs) cd cs
                                        x17 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_fcyFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "Renamed")) x7 cd cs) cd cs
                                        x18 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_ahsFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "FunDecls")) x7 cd cs) cd cs
                                        x19 = Curry_Prelude.d_OP_dollar
                                          d_OP_compileModule_dot_ahsFile_dot_56
                                          (Curry_Files.d_C_withBaseName
                                          (Curry_Prelude.d_C_flip (acceptCs id
                                          Curry_Prelude.d_OP_plus_plus)
                                          (Curry_Prelude.toCurryString
                                          "TypeDecls")) x7 cd cs) cd cs
                                        x20 = d_OP_compileModule_dot_ahsFile_dot_56
                                          x7 cd cs
                                        x21 = Curry_TransFunctions.d_C_compOptions
                                          x3 cd cs
                                        x22 = Curry_Names.d_C_destFile
                                          (Curry_CompilerOpts.d_C_optTraceFailure
                                          x21 cd cs)
                                          (Curry_CompilerOpts.d_C_optOutputSubdir
                                          x21 cd cs) x7 x9 cd cs
                                        x23 = Curry_Names.d_C_funcInfoFile
                                          (Curry_CompilerOpts.d_C_optOutputSubdir
                                          x21 cd cs) x7 x9 cd cs
    in Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
    (Curry_Message.d_C_showStatus x21) (d_C_compMessage (Curry_Prelude.OP_Tuple2
    x6 x2) (Curry_Prelude.toCurryString "Compiling") x7 (Curry_Prelude.OP_Tuple2
    x9 x22) cd cs) cd cs) (let x24 = d_C_filterPrelude x21 x10 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpFlat x21 x11
    (Curry_Prelude.d_C_show x24 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Inferring types") cd cs) (let x25 = Curry_Prelude.d_C_either
                                     Curry_Prelude.d_C_error
                                     Curry_Prelude.d_C_id
                                     (Curry_Inference.d_C_inferProgFromProgEnv
                                     x1 x10 cd cs) cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpTypedFlat x21
    x12 (Curry_Prelude.d_C_show x25 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Lifting case expressions") cd cs) (let x26 = Curry_LiftCase.d_C_liftCases
                                              Curry_Prelude.C_True x25 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpLifted x21
    x14 (Curry_Prelude.d_C_show x26 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Eliminate calls to cond") cd cs)
    (let x27 = Curry_EliminateCond.d_C_eliminateCond x26 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpEliminated
    x21 x15 (Curry_Prelude.d_C_show x27 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Default locally polymorphic sub-expressions") cd cs)
    (let x28 = Curry_Prelude.d_C_apply
           (Curry_DefaultPolymorphic.d_C_defaultPolymorphic cd cs) x27 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpDefaulted x21
    x16 (Curry_Prelude.d_C_show x28 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Extending imports") cd cs)
    (let x29 = Curry_MissingImports.d_C_fixMissingImports x28 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpExtImports
    x21 x13 (Curry_Prelude.d_C_show x29 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Renaming symbols") cd cs) (let x30 = d_C_rename (Curry_Prelude.d_C_apply
                                      (Curry_AnnotatedFlatCurryGoodies.d_C_unAnnProg
                                      cd cs) x29 cd cs) cd cs
                                    x31 = d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed
                                      x30 cd cs
                                    x32 = d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts
                                      x30 cd cs
    in Curry_Prelude.d_OP_gt_gt (d_C_dump Curry_CompilerOpts.C_DumpRenamed x21
    x17 (Curry_Prelude.d_C_show x31 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Transforming functions") cd cs) (Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Prelude.d_C_apply (Curry_TransFunctions.d_C_runIOES
    (Curry_TransFunctions.d_C_trProg x31 cd cs) cd cs) x3 cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda49 x20 x22 x9 x18 x23 x7 x21 x32
    x19) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs)
    cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_20 x7 x3 x1 x2
    x6 l cd cs) (d_C__case_20 x7 x3 x1 x2 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_20
    x7 x3 x1 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_20 x7 x3 x1 x2
    x6 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_20" [show x7, show x3, show x1, show x2, show x6, show x8]
    info)
  _ -> failCons cd (consFail "Compile._case_20" (showCons x8))

nd_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_20 x7 x3 x1 x2 x6 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s73 = s
    in s73 `seq` (let s74 = leftSupply s73
                      s78 = rightSupply s73
                      s75 = leftSupply s74
                      s76 = rightSupply s74
                      s2 = leftSupply s75
                      s5 = rightSupply s75
                      s8 = leftSupply s76
                      s77 = rightSupply s76
                      s11 = leftSupply s77
                      s14 = rightSupply s77
                      s79 = leftSupply s78
                      s81 = rightSupply s78
                      s17 = leftSupply s79
                      s80 = rightSupply s79
                      s20 = leftSupply s80
                      s23 = rightSupply s80
                      s26 = leftSupply s81
                      s82 = rightSupply s81
                      s27 = leftSupply s82
                      s71 = rightSupply s82
    in s74 `seq` (s78 `seq` (s75 `seq` (s76 `seq` (s2 `seq` (s5 `seq` (s8 `seq`
    (s77 `seq` (s11 `seq` (s14 `seq` (s79 `seq` (s81 `seq` (s17 `seq` (s80 `seq`
    (s20 `seq` (s23 `seq` (s26 `seq` (s82 `seq` (s27 `seq` (s71 `seq`
    (let x11 = let s1 = leftSupply s2
                   s0 = rightSupply s2
           in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString "Dump")))
           x7 s0 cd cs) s1 cd cs)
         x12 = let s4 = leftSupply s5
                   s3 = rightSupply s5
           in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "Typed"))) x7 s3 cd cs) s4 cd cs)
         x13 = let s7 = leftSupply s8
                   s6 = rightSupply s8
           in s7 `seq` (s6 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "ExtImports"))) x7 s6 cd cs) s7 cd cs)
         x14 = let s10 = leftSupply s11
                   s9 = rightSupply s11
           in s10 `seq` (s9 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "Lifted"))) x7 s9 cd cs) s10 cd cs)
         x15 = let s13 = leftSupply s14
                   s12 = rightSupply s14
           in s13 `seq` (s12 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "ElimCond"))) x7 s12 cd cs) s13 cd cs)
         x16 = let s16 = leftSupply s17
                   s15 = rightSupply s17
           in s16 `seq` (s15 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "Defaulted"))) x7 s15 cd cs) s16 cd cs)
         x17 = let s19 = leftSupply s20
                   s18 = rightSupply s20
           in s19 `seq` (s18 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_fcyFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "Renamed"))) x7 s18 cd cs) s19 cd cs)
         x18 = let s22 = leftSupply s23
                   s21 = rightSupply s23
           in s22 `seq` (s21 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_ahsFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "FunDecls"))) x7 s21 cd cs) s22 cd cs)
         x19 = let s25 = leftSupply s26
                   s24 = rightSupply s26
           in s25 `seq` (s24 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
           d_OP_compileModule_dot_ahsFile_dot_56) (Curry_Files.nd_C_withBaseName
           (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
           Curry_Prelude.d_OP_plus_plus)) (Curry_Prelude.toCurryString
           "TypeDecls"))) x7 s24 cd cs) s25 cd cs)
         x20 = d_OP_compileModule_dot_ahsFile_dot_56 x7 cd cs
         x21 = Curry_TransFunctions.nd_C_compOptions x3 s27 cd cs
         x22 = Curry_Names.d_C_destFile (Curry_CompilerOpts.d_C_optTraceFailure
           x21 cd cs) (Curry_CompilerOpts.d_C_optOutputSubdir x21 cd cs) x7 x9
           cd cs
         x23 = Curry_Names.d_C_funcInfoFile
           (Curry_CompilerOpts.d_C_optOutputSubdir x21 cd cs) x7 x9 cd cs
    in let s70 = leftSupply s71
           s72 = rightSupply s71
           s28 = leftSupply s72
           s69 = rightSupply s72
    in s70 `seq` (s72 `seq` (s28 `seq` (s69 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showStatus x21))
    (d_C_compMessage (Curry_Prelude.OP_Tuple2 x6 x2)
    (Curry_Prelude.toCurryString "Compiling") x7 (Curry_Prelude.OP_Tuple2 x9
    x22) cd cs) s28 cd cs) (let x24 = d_C_filterPrelude x21 x10 cd cs
    in let s68 = leftSupply s69
           s67 = rightSupply s69
    in s68 `seq` (s67 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpFlat x21 x11 (Curry_Prelude.d_C_show x24 cd cs) cd
    cs) (let s66 = leftSupply s67
             s65 = rightSupply s67
    in s66 `seq` (s65 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Inferring types") cd cs) (let s29 = leftSupply s65
                                   s64 = rightSupply s65
    in s29 `seq` (s64 `seq` (let x25 = Curry_Prelude.nd_C_either (wrapDX id
                                   Curry_Prelude.d_C_error) (wrapDX id
                                   Curry_Prelude.d_C_id)
                                   (Curry_Inference.d_C_inferProgFromProgEnv x1
                                   x10 cd cs) s29 cd cs
    in let s63 = leftSupply s64
           s62 = rightSupply s64
    in s63 `seq` (s62 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpTypedFlat x21 x12 (Curry_Prelude.d_C_show x25 cd
    cs) cd cs) (let s61 = leftSupply s62
                    s60 = rightSupply s62
    in s61 `seq` (s60 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Lifting case expressions") cd cs) (let x26 = Curry_LiftCase.d_C_liftCases
                                              Curry_Prelude.C_True x25 cd cs
    in let s59 = leftSupply s60
           s58 = rightSupply s60
    in s59 `seq` (s58 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpLifted x21 x14 (Curry_Prelude.d_C_show x26 cd cs)
    cd cs) (let s57 = leftSupply s58
                s56 = rightSupply s58
    in s57 `seq` (s56 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Eliminate calls to cond") cd cs)
    (let x27 = Curry_EliminateCond.d_C_eliminateCond x26 cd cs
    in let s55 = leftSupply s56
           s54 = rightSupply s56
    in s55 `seq` (s54 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpEliminated x21 x15 (Curry_Prelude.d_C_show x27 cd
    cs) cd cs) (let s53 = leftSupply s54
                    s52 = rightSupply s54
    in s53 `seq` (s52 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Default locally polymorphic sub-expressions") cd cs) (let s30 = leftSupply
                                                                 s52
                                                               s51 = rightSupply
                                                                 s52
    in s30 `seq` (s51 `seq` (let x28 = Curry_Prelude.nd_C_apply (wrapDX id
                                   (Curry_DefaultPolymorphic.d_C_defaultPolymorphic
                                   cd cs)) x27 s30 cd cs
    in let s50 = leftSupply s51
           s49 = rightSupply s51
    in s50 `seq` (s49 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpDefaulted x21 x16 (Curry_Prelude.d_C_show x28 cd
    cs) cd cs) (let s48 = leftSupply s49
                    s47 = rightSupply s49
    in s48 `seq` (s47 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Extending imports") cd cs)
    (let x29 = Curry_MissingImports.d_C_fixMissingImports x28 cd cs
    in let s46 = leftSupply s47
           s45 = rightSupply s47
    in s46 `seq` (s45 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpExtImports x21 x13 (Curry_Prelude.d_C_show x29 cd
    cs) cd cs) (let s44 = leftSupply s45
                    s43 = rightSupply s45
    in s44 `seq` (s43 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Renaming symbols") cd cs) (let s31 = leftSupply s43
                                    s42 = rightSupply s43
    in s31 `seq` (s42 `seq` (let x30 = d_C_rename (Curry_Prelude.nd_C_apply
                                   (wrapDX id
                                   (Curry_AnnotatedFlatCurryGoodies.d_C_unAnnProg
                                   cd cs)) x29 s31 cd cs) cd cs
                                 x31 = d_OP_compileModule_dot_uscore_hash_selFP12_hash_renamed
                                   x30 cd cs
                                 x32 = d_OP_compileModule_dot_uscore_hash_selFP13_hash_ts
                                   x30 cd cs
    in let s41 = leftSupply s42
           s40 = rightSupply s42
    in s41 `seq` (s40 `seq` Curry_Prelude.nd_OP_gt_gt (d_C_dump
    Curry_CompilerOpts.C_DumpRenamed x21 x17 (Curry_Prelude.d_C_show x31 cd cs)
    cd cs) (let s39 = leftSupply s40
                s38 = rightSupply s40
    in s39 `seq` (s38 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Message.d_C_showDetail x21 (Curry_Prelude.toCurryString
    "Transforming functions") cd cs) (let s37 = leftSupply s38
                                          s36 = rightSupply s38
    in s37 `seq` (s36 `seq` Curry_Prelude.nd_OP_gt_gt_eq (let s35 = leftSupply
                                                                s36
                                                              s34 = rightSupply
                                                                s36
    in s35 `seq` (s34 `seq` Curry_Prelude.nd_C_apply (let s33 = leftSupply s34
                                                          s32 = rightSupply s34
    in s33 `seq` (s32 `seq` Curry_TransFunctions.nd_C_runIOES
    (Curry_TransFunctions.nd_C_trProg x31 s32 cd cs) s33 cd cs)) x3 s35 cd cs))
    (wrapNX id (nd_OP_compileModule_dot_uscore_hash_lambda49 x20 x22 x9 x18 x23
    x7 x21 x32 x19)) s37 cd cs)) s39 cd cs)) s41 cd cs)))) s44 cd cs)) s46 cd
    cs)) s48 cd cs)) s50 cd cs)))) s53 cd cs)) s55 cd cs)) s57 cd cs)) s59 cd
    cs)) s61 cd cs)) s63 cd cs)))) s66 cd cs)) s68 cd cs)) s70 cd
    cs))))))))))))))))))))))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_20 x7 x3 x1
    x2 x6 l s cd cs) (nd_C__case_20 x7 x3 x1 x2 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_20
    x7 x3 x1 x2 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_20 x7 x3 x1
    x2 x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_20" [show x7, show x3, show x1, show x2, show x6, show x8]
    info)
  _ -> failCons cd (consFail "Compile._case_20" (showCons x8))

d_C__case_22 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_FuncHOClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_TransFunctions.C_State
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_22 x7 x6 x5 x4 x3 x1 cd cs = case x1 of
  Curry_TransFunctions.C_State x8 x9 x10 x11 x12 x13 x14 x15 -> Curry_TransFunctions.C_State
    (Curry_FiniteMap.d_C_plusFM (Curry_TransFunctions.d_C_typeMap x1 cd cs) x3
    cd cs) (Curry_FiniteMap.d_C_plusFM (Curry_TransFunctions.d_C_ndResult x1 cd
    cs) x4 cd cs) (Curry_FiniteMap.d_C_plusFM
    (Curry_TransFunctions.d_C_hoResultType x1 cd cs) x5 cd cs)
    (Curry_FiniteMap.d_C_plusFM (Curry_TransFunctions.d_C_hoResultCons x1 cd cs)
    x6 cd cs) (Curry_FiniteMap.d_C_plusFM (Curry_TransFunctions.d_C_hoResultFunc
    x1 cd cs) x7 cd cs) x13 x14 x15
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (d_C__case_22 x7 x6
    x5 x4 x3 l cd cs) (d_C__case_22 x7 x6 x5 x4 x3 r cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    d_C__case_22 x7 x6 x5 x4 x3 z cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (d_C__case_22 x7 x6
    x5 x4 x3 e cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_22" [show x7, show x6, show x5, show x4, show x3, show x1]
    info)
  _ -> failCons cd (consFail "Compile._case_22" (showCons x1))

nd_C__case_22 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_FuncHOClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_TransFunctions.C_State
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_22 x7 x6 x5 x4 x3 x1 s cd cs = case x1 of
  Curry_TransFunctions.C_State x8 x9 x10 x11 x12 x13 x14 x15 -> let s15 = s
    in s15 `seq` (let s16 = leftSupply s15
                      s17 = rightSupply s15
                      s2 = leftSupply s16
                      s5 = rightSupply s16
                      s8 = leftSupply s17
                      s18 = rightSupply s17
                      s11 = leftSupply s18
                      s14 = rightSupply s18
    in s16 `seq` (s17 `seq` (s2 `seq` (s5 `seq` (s8 `seq` (s18 `seq` (s11 `seq`
    (s14 `seq` Curry_TransFunctions.C_State (let s1 = leftSupply s2
                                                 s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_FiniteMap.nd_C_plusFM
    (Curry_TransFunctions.nd_C_typeMap x1 s0 cd cs) x3 s1 cd cs))
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_FiniteMap.nd_C_plusFM
    (Curry_TransFunctions.nd_C_ndResult x1 s3 cd cs) x4 s4 cd cs))
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_FiniteMap.nd_C_plusFM
    (Curry_TransFunctions.nd_C_hoResultType x1 s6 cd cs) x5 s7 cd cs))
    (let s10 = leftSupply s11
         s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_FiniteMap.nd_C_plusFM
    (Curry_TransFunctions.nd_C_hoResultCons x1 s9 cd cs) x6 s10 cd cs))
    (let s13 = leftSupply s14
         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_FiniteMap.nd_C_plusFM
    (Curry_TransFunctions.nd_C_hoResultFunc x1 s12 cd cs) x7 s13 cd cs)) x13 x14
    x15))))))))
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (nd_C__case_22 x7 x6
    x5 x4 x3 l s cd cs) (nd_C__case_22 x7 x6 x5 x4 x3 r s cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    nd_C__case_22 x7 x6 x5 x4 x3 z s cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (nd_C__case_22 x7 x6
    x5 x4 x3 e s cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_22" [show x7, show x6, show x5, show x4, show x3, show x1]
    info)
  _ -> failCons cd (consFail "Compile._case_22" (showCons x1))

d_C__case_24 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_24 x2 x1 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_23 x6 x2 x1 x5 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_24 x2 x1 x5 l
    cd cs) (d_C__case_24 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_24
    x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_24 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_24" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_24" (showCons x4))

nd_C__case_24 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_24 x2 x1 x5 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_23 x6 x2 x1 x5 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_24 x2 x1 x5 l
    s cd cs) (nd_C__case_24 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_24
    x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_24 x2 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_24" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_24" (showCons x4))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C__case_23 x6 x2 x1 x5 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let x10 = Curry_TransFunctions.d_C_compOptions
                                         x2 cd cs
                                       x11 = Curry_Names.d_C_analysisFile
                                         (Curry_CompilerOpts.d_C_optOutputSubdir
                                         x10 cd cs) x6 x8 cd cs
    in Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
    (Curry_Message.d_C_showStatus x10) (d_C_compMessage (Curry_Prelude.OP_Tuple2
    x5 x1) (Curry_Prelude.toCurryString "Analyzing") x6 (Curry_Prelude.OP_Tuple2
    x8 x11) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq (d_C_readAnalysis x10 x6
    x8 cd cs) (d_OP_loadAnalysis_dot_uscore_hash_lambda39 x2) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_23 x6 x2 x1 x5
    l cd cs) (d_C__case_23 x6 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_23
    x6 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_23 x6 x2 x1 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_23" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_23" (showCons x7))

nd_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_23 x6 x2 x1 x5 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s8 = s
    in s8 `seq` (let s0 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s6 `seq` (let x10 = Curry_TransFunctions.nd_C_compOptions x2 s0
                                 cd cs
                               x11 = Curry_Names.d_C_analysisFile
                                 (Curry_CompilerOpts.d_C_optOutputSubdir x10 cd
                                 cs) x6 x8 cd cs
    in let s5 = leftSupply s6
           s7 = rightSupply s6
           s1 = leftSupply s7
           s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq` Curry_Prelude.nd_OP_gt_gt
    (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showStatus x10))
    (d_C_compMessage (Curry_Prelude.OP_Tuple2 x5 x1)
    (Curry_Prelude.toCurryString "Analyzing") x6 (Curry_Prelude.OP_Tuple2 x8
    x11) cd cs) s1 cd cs) (let s3 = leftSupply s4
                               s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_gt_gt_eq (nd_C_readAnalysis x10 x6
    x8 s2 cd cs) (wrapNX id (nd_OP_loadAnalysis_dot_uscore_hash_lambda39 x2)) s3
    cd cs)) s5 cd cs))))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_23 x6 x2 x1
    x5 l s cd cs) (nd_C__case_23 x6 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_23
    x6 x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_23 x6 x2 x1
    x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_23" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_23" (showCons x7))

d_C__case_25 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
d_C__case_25 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x3 x6) x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_25 x2 x3 l cd
    cs) (d_C__case_25 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_25
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_25 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_25" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_25" (showCons x4))

d_C__case_26 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_26 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x1 l cd cs)
    (d_C__case_26 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_26 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_26"
    [show x1, show x6] info)
  _ -> failCons cd (consFail "Compile._case_26" (showCons x6))

d_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_30 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_29 x1 x2 x3 x6 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_30 x1 x2 x3 l
    cd cs) (d_C__case_30 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_30
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_30 x1 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_30" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_30" (showCons x4))

nd_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_30 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_29 x1 x2 x3 x6 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_30 x1 x2 x3 l
    s cd cs) (nd_C__case_30 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_30
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_30 x1 x2 x3 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_30" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_30" (showCons x4))

d_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_29 x1 x2 x3 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let x10 = Curry_Prelude.d_C_apply
                                         (Curry_Names.d_C_externalFile cd cs) x8
                                         cd cs
                                       x11 = d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps
                                         x9 cd cs
                                       x12 = Curry_TransFunctions.d_C_compOptions
                                         x2 cd cs
                                       x13 = Curry_Prelude.d_OP_gt_gt_eq
                                         (Curry_Directory.d_C_doesFileExist x10
                                         cd cs)
                                         (d_OP_makeModule_dot_uscore_hash_lambda32
                                         x10 x8 x11 x1 x12) cd cs
                                       x14 = Curry_Prelude.d_C_length x1 cd cs
                                       x15 = Curry_Prelude.d_C_foldr (acceptCs
                                         id
                                         d_OP_makeModule_dot_uscore_hash_lambda36)
                                         Curry_Prelude.OP_List x1 cd cs
    in d_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13 (Curry_CompilerOpts.d_C_optForce
    x12 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_29 x1 x2 x3 x6
    l cd cs) (d_C__case_29 x1 x2 x3 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_29
    x1 x2 x3 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_29 x1 x2 x3 x6
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_29" [show x1, show x2, show x3, show x6, show x7] info)
  _ -> failCons cd (consFail "Compile._case_29" (showCons x7))

nd_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_29 x1 x2 x3 x6 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s5 = s
    in s5 `seq` (let s6 = leftSupply s5
                     s7 = rightSupply s5
                     s0 = leftSupply s6
                     s1 = rightSupply s6
                     s2 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
    (s4 `seq` (let x10 = Curry_Prelude.nd_C_apply (wrapDX id
                     (Curry_Names.d_C_externalFile cd cs)) x8 s0 cd cs
                   x11 = d_OP_makeModule_dot_uscore_hash_selFP2_hash_imps x9 cd
                     cs
                   x12 = Curry_TransFunctions.nd_C_compOptions x2 s1 cd cs
                   x13 = Curry_Prelude.nd_OP_gt_gt_eq
                     (Curry_Directory.d_C_doesFileExist x10 cd cs) (wrapDX id
                     (d_OP_makeModule_dot_uscore_hash_lambda32 x10 x8 x11 x1
                     x12)) s2 cd cs
                   x14 = Curry_Prelude.d_C_length x1 cd cs
                   x15 = Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs
                     id d_OP_makeModule_dot_uscore_hash_lambda36))
                     Curry_Prelude.OP_List x1 s3 cd cs
    in nd_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13
    (Curry_CompilerOpts.d_C_optForce x12 cd cs) s4 cd cs)))))))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_29 x1 x2 x3
    x6 l s cd cs) (nd_C__case_29 x1 x2 x3 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_29
    x1 x2 x3 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_29 x1 x2 x3
    x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_29" [show x1, show x2, show x3, show x6, show x7] info)
  _ -> failCons cd (consFail "Compile._case_29" (showCons x7))

d_C__case_28 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_compileModule x15 x14 x2 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x12 x2 x15 x14
    x3 x6 x8 x13 l cd cs) (d_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x12
    x2 x15 x14 x3 x6 x8 x13 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_28 x12 x2 x15 x14
    x3 x6 x8 x13 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_28"
    [show x12, show x2, show x15, show x14, show x3, show x6, show x8, show x13
    , show x16] info)
  _ -> failCons cd (consFail "Compile._case_28" (showCons x16))

nd_C__case_28 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_compileModule x15 x14 x2 x3 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_28 x12 x2 x15
    x14 x3 x6 x8 x13 l s cd cs) (nd_C__case_28 x12 x2 x15 x14 x3 x6 x8 x13 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_28 x12
    x2 x15 x14 x3 x6 x8 x13 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_28 x12 x2 x15
    x14 x3 x6 x8 x13 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_28"
    [show x12, show x2, show x15, show x14, show x3, show x6, show x8, show x13
    , show x16] info)
  _ -> failCons cd (consFail "Compile._case_28" (showCons x16))

d_C__case_27 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq x13
    (d_OP_makeModule_dot_uscore_hash_lambda38 x8 x6 x3 x14 x12 x15 x2) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x2 x15 x12 x14
    x3 x6 x8 x13 l cd cs) (d_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x2
    x15 x12 x14 x3 x6 x8 x13 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_27 x2 x15 x12 x14
    x3 x6 x8 x13 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_27"
    [show x2, show x15, show x12, show x14, show x3, show x6, show x8, show x13
    , show x16] info)
  _ -> failCons cd (consFail "Compile._case_27" (showCons x16))

nd_C__case_27 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog) -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq x13 (wrapNX id
    (nd_OP_makeModule_dot_uscore_hash_lambda38 x8 x6 x3 x14 x12 x15 x2)) s0 cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x2 x15 x12
    x14 x3 x6 x8 x13 l s cd cs) (nd_C__case_27 x2 x15 x12 x14 x3 x6 x8 x13 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x2
    x15 x12 x14 x3 x6 x8 x13 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_27 x2 x15 x12
    x14 x3 x6 x8 x13 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_27"
    [show x2, show x15, show x12, show x14, show x3, show x6, show x8, show x13
    , show x16] info)
  _ -> failCons cd (consFail "Compile._case_27" (showCons x16))

d_C__case_31 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_31 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_foldIO
    (acceptCs id (d_C_makeModule x3)) x1 (Curry_Prelude.d_C_zip x3
    (Curry_Prelude.d_C_enumFrom (Curry_Prelude.C_Int 1#) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_done cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO_
    Curry_Message.d_C_putErrLn cd cs) x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x4 x3 x1 l cd
    cs) (d_C__case_31 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_31 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_31"
    [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Compile._case_31" (showCons x5))

nd_C__case_31 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C__case_31 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_gt_gt (Curry_Prelude.nd_C_foldIO
    (wrapDX (wrapNX id) (acceptCs id (nd_C_makeModule x3))) x1
    (Curry_Prelude.d_C_zip x3 (Curry_Prelude.d_C_enumFrom (Curry_Prelude.C_Int
    1#) cd cs) cd cs) s0 cd cs) (Curry_Prelude.d_C_done cd cs) s1 cd cs))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapIO_
    (wrapDX id Curry_Message.d_C_putErrLn) s0 cd cs) x4 s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x4 x3 x1 l s
    cd cs) (nd_C__case_31 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x4
    x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_31 x4 x3 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_31"
    [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Compile._case_31" (showCons x5))

d_C__case_32 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_32 x1 x12 cd cs = case x12 of
  Curry_TransFunctions.C_State x4 x5 x6 x7 x8 x9 x10 x11 -> Curry_TransFunctions.C_State
    x4 x5 x6 x7 x8 x9 x10 x1
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (d_C__case_32 x1 l
    cd cs) (d_C__case_32 x1 r cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    d_C__case_32 x1 z cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (d_C__case_32 x1 e
    cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_32" [show x1, show x12] info)
  _ -> failCons cd (consFail "Compile._case_32" (showCons x12))

nd_C__case_32 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_32 x1 x12 s cd cs = case x12 of
  Curry_TransFunctions.C_State x4 x5 x6 x7 x8 x9 x10 x11 -> Curry_TransFunctions.C_State
    x4 x5 x6 x7 x8 x9 x10 x1
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (nd_C__case_32 x1 l
    s cd cs) (nd_C__case_32 x1 r s cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    nd_C__case_32 x1 z s cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (nd_C__case_32 x1 e
    s cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_32" [show x1, show x12] info)
  _ -> failCons cd (consFail "Compile._case_32" (showCons x12))

d_C__case_33 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_CompilerOpts.C_Options -> Cover -> ConstStore
  -> Curry_CompilerOpts.C_Options
d_C__case_33 x1 x2 x4 cd cs = case x4 of
  Curry_CompilerOpts.C_Opts x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 -> Curry_CompilerOpts.C_Opts
    x6 x7 x8 (Curry_CompilerOpts.d_C_optVerbosity x4 cd cs) x10 x11 x12 x13 x14
    x15 x16 x17 (Curry_RCFile.d_C_updateRCDefs x2 (Curry_Prelude.d_C_snd
    (Curry_RCFile.d_C_extractRCArgs x1 cd cs) cd cs) cd cs)
  Curry_CompilerOpts.Choice_C_Options d i l r -> narrow d i (d_C__case_33 x1 x2
    l cd cs) (d_C__case_33 x1 x2 r cd cs)
  Curry_CompilerOpts.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_33 x1 x2 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Options d c e -> guardCons d c (d_C__case_33 x1 x2
    e cd $! addCs c cs)
  Curry_CompilerOpts.Fail_C_Options d info -> failCons d (traceFail
    "Compile._case_33" [show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "Compile._case_33" (showCons x4))

